/**
* Главный класс l-lacker Social API
*/
class SocialAPI {
    /**
    * @param {string} token - ваш аунтентификационный токен.
    */
    constructor(token = null) {
        this.token = token;
        this.baseURL = "http://l-lsoc.cf/api/";
    }
    
    /**
    * Вызвать метод API, возвращает сразу результат, или выбрасывает ошибку.
    * Работает через промисы
    * @param {string} method - метод API
    * @param {array} params - параметры в массиве
    * @param {boolean} is_write - записать данные вместо получения
    * @param {object} data - данные для записи
    */
    async api(method, params, is_write = !1, data = {}) {
        return new Promise((resolve, reject) => {
            let xhr = new XMLHttpRequest();
            let url = this.baseURL+method+"/"+params.join("/")+"/"+(this.token == null ? "?" : `?access_token=${this.token}`);
            xhr.open(is_write ? "POST" : "GET", url, true);
            void(is_write ? url+="&override_method" : !1);
            xhr.onreadystatechange = () => {
                if(xhr.readyState === 4) {
                    let response = JSON.parse(xhr.responseText);
                    if(response.error) {
                        reject(new (class ApiException extends Error {
                            constructor(description) {
                                super(description);
                            }
                        })(response.description));
                    }
                    resolve(response.result);
                }
            };
            xhr.send(JSON.stringify(data));
        });
    }
}